#include <bits/stdc++.h>

using namespace std;

ifstream fi ("strd4.inp");
ofstream fo ("strd4.out");

int main(){
 string s,a;
 std:getline(fi,s);
 int n = s.length(), k,num=0;
 for (int i=0;i<n;i++){
    if (s[i]=='0'||s[i]=='4'||s[i]=='8') num++;
    a = s[i];
    if (i>0){
        a=s[i-1]+a;
        k=atoi(a.c_str());
        if (k%4==0){
            num=num+i;
        }
    }
 }
 fo<<num;
}
